package nl.amis.view.bundles;


import com.rsa.certj.DatabaseService;

import java.util.Collections;
import java.util.HashMap;
import java.util.Iterator;
import java.util.ListResourceBundle;
import java.util.Map;

import oracle.adf.model.BindingContext;
import oracle.adf.model.binding.DCBindingContainer;
import oracle.adf.model.binding.DCDataControl;

import oracle.jbo.uicli.binding.JUCtrlActionBinding;

public abstract class DatabaseResourceBundle extends ListResourceBundle {
    private Object[][] stored = null;
    private final String GENERIC_PAGEDEFINITION =
        "nl_amis_simple_view_GenericPageDef";



    protected Object[][] getContents() {
        System.out.println("getContents for "+getLocaleCode());
        if (stored == null) {
            initResourceBundle();
        }
        return stored;
    }


    abstract public String getContext1();

    /** synchronized initialization of reading resource bundle */
    private synchronized void initResourceBundle() {
        Map map = new HashMap();
        map = getResourceBundle(getLocaleCode(),getContext1());

        // copy all values from map in object array
        if (map.size() == 0) {
            stored = new Object[0][0];
        } else {
            Object[][] returnValue = new Object[map.size()][2];
            int ii = 0;
            for (Iterator keyIter = map.keySet().iterator(); keyIter.hasNext();
            ) {
                Object key = keyIter.next();
                returnValue[ii][0] = key;
                returnValue[ii][1] = map.get(key);
                ii++;
            }
            stored = returnValue;
        }
    }


    public String getLocaleCode() {
        return "en";
    }

    private Map getResourceBundle(String locale, String context) {
        Map map = new HashMap();
        BindingContext bindingContext = BindingContext.getCurrent();
        if (bindingContext == null) {
            throw new RuntimeException("No ADFM Binding Context found!!");
        }
        DCBindingContainer container =
            bindingContext.findBindingContainer(GENERIC_PAGEDEFINITION);
        if (container != null) {
            JUCtrlActionBinding getResourceBundleBinding =
                (JUCtrlActionBinding)container.findCtrlBinding("getResourceBundle");
            getResourceBundleBinding.getParamsMap().put("locale", locale);
            getResourceBundleBinding.getParamsMap().put("context", context);
            Object result = getResourceBundleBinding.execute();
            if (result instanceof Map) {
                map = (Map)result;
            }
        }
        return map;
    }

}
